﻿using System;
using System.Windows.Forms;

namespace TestVoiceNET
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            radioButton1.Checked = true;
            DirectVoice.Enabled = false;

            m_SoftCodec = new SoftCodec(this);
        }

        public void PutLog(String aMes)
        {
            Log.BeginInvoke((MethodInvoker)(() => this.Log.Text += aMes+"\r\n"));
        }

        public void Stop()
        {
            m_SoftCodec.Stop();

            button1.BeginInvoke((MethodInvoker)(() => button1.Text = "Enable voice communication"));
            DirectVoice.BeginInvoke((MethodInvoker)(() => DirectVoice.Enabled = false));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(m_SoftCodec.IsStart)
            {
                Stop();
            }
            else
            {
                try
                {
                    m_IndexLU = Int32.Parse(IndexLU.Text, System.Globalization.NumberStyles.None, null);
                    if (m_IndexLU < 1 || m_IndexLU >= 0xFFFF) throw new Exception("Bad IndexLU");

                    if (m_Mode == 2)
                    {
                        m_AddrIntercom = Int32.Parse(AddrIntercom.Text, System.Globalization.NumberStyles.None, null);
                        if (m_AddrIntercom < 1 || m_AddrIntercom >= 0xFF) throw new Exception("Bad AddrIntercom");
                    }

                    m_SoftCodec.Start(m_IndexLU, m_Mode == 2? m_AddrIntercom: m_Mode);
                    this.button1.Text = "Turn off voice communication";
                    DirectVoice.Text = m_SoftCodec.IsListen ? "Listen, press and release to speak" : "Speak, press and release to listen";
                    DirectVoice.Enabled = true;

                }
                catch (Exception aErr)
                {
                    MessageBox.Show(aErr.Message, "Param", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    return;
                }
            }
        }

        private void Intercom_Click(object sender, EventArgs e)
        {
            m_Mode = 2;

            AddrIntercom.Enabled = true;
        }


        private void MR_Click(object sender, EventArgs e)
        {
            m_Mode = 0;

            AddrIntercom.Enabled = false;
        }


        private void Cabin_Click(object sender, EventArgs e)
        {
            m_Mode = 1;

            AddrIntercom.Enabled = false;
        }

        SoftCodec m_SoftCodec;

        int m_IndexLU = 0;
        int m_Mode = 0;
        int m_AddrIntercom = 0;

        private void DirectVoice_Click(object sender, EventArgs e)
        {
            m_SoftCodec.ChangDirectionVoice();
            DirectVoice.Text = m_SoftCodec.IsListen ? "Listen, press and release to speak" : "Speak, press and release to listen";
        }
    }
}
