﻿using System;

namespace TestVoiceNET
{
    class G723Pack
    {
        public G723Pack()
        {
            Array.Clear(m_Data, 0, m_Data.Length);

            m_Data[voiceLen + 0] = lenSuffix;
        }
        public G723Pack(int aLen, byte[] aBody)
        {
            Array.Clear(m_Data, 0, m_Data.Length);

            if (aLen <= lenBuf)
            {
                Array.Copy(aBody, m_Data, aLen);
            }
        }

        public void GetVoice(byte[] aVoice)
        {
            Array.Copy(m_Data, aVoice, voiceLen);
        }
        public void SetVoice(byte[] aVoice)
        {
            Array.Copy(aVoice, m_Data, voiceLen);
        }

        public Guid GetGUID()
        {
            byte[] GuidByte = new byte[16];

            Array.Copy(m_Data, voiceLen + 10, GuidByte, 0, 16);

            return new Guid(GuidByte);
        }
        public void SetGUID(Guid aID)
        {
            Array.Copy(aID.ToByteArray(), 0, m_Data, voiceLen + 10, 16);
        }

        public void SetTyp(typPack aTyp)
        {
            m_Data[voiceLen + 26] = (byte)aTyp;
        }

        public typPack GetTyp()
        {
            return (typPack)m_Data[voiceLen + 26];
        }

        public codError GetError()
        {
            if (GetTyp() == typPack.tpError)
            {
                return (codError)m_Data[voiceLen + lenSuffix];
            }
            else
            {
                return codError.ceNone;
            }
        }

        public void SetDestPoint(int aDestPoint)
        {
            m_Data[voiceLen + 8] = (byte)aDestPoint;
        }

        public int Len
        {
            get { return lenBuf; }
        }

        public byte[] Data
        {
            get { return m_Data; }
        }

        public enum typPack
        {                           // типы пакетов
            tpMaster = 0x00,    // звуковой пакет Master
            tpSlave = 0x80, // звуковой пакет Slave
            tpLoopRequest = 0x01,   // звуковой пакет LOOP REQUEST
            tpLoopAnswer = 0x81,    // звуковой пакет LOOP ANSWER
            tpTraceRequest = 0x02,  // звуковой пакет TRACE REQUEST
            tpTraceAnswer = 0x82,   // звуковой пакет TRACE ANSWER
            tpError = 0xFE, // оповещение об ошибке
        };

        public enum codError
        {                       // ошибка
            ceNone = -1,    // нет ошибки
            ceBUSY = 0, // занято
            ceBadFormat = 1,    // формат данных не поддерживается
        };

        public static int LenBuf
        {
            get { return lenBuf; }
        }
        const int voiceLen = 97;
        const int lenSuffix = 27;
        const int lenBuf = voiceLen + lenSuffix + 1;

        byte[] m_Data = new byte[lenBuf];
    }
}
