﻿using System;
using System.Collections.Generic;
using System.Threading;

namespace TestVoiceNET
{
    class WavPack
    {
        public WavPack()
        {
            m_Len = 0;
        }
        public WavPack(int aLen, short[] aData)
        {
            m_Len = aLen <= lenBuf? aLen: lenBuf;
            Array.Copy(aData, m_Data, m_Len);
        }
        public WavPack(WavPack aPack)
        {
            m_Len = aPack.m_Len;
            Array.Copy(aPack.m_Data, m_Data, m_Len);
        }
        public int Len
        {
            get { return m_Len; }
        }
        public short[] Data
        {
            get { return m_Data; }
        }
        const int lenBuf = 960;
        int m_Len = 0;
        short[] m_Data = new short[lenBuf];

    }

    class WavPackQueue : Queue<WavPack>
    {
        EventWaitHandle m_Lock = new EventWaitHandle(true, EventResetMode.AutoReset);
        EventWaitHandle m_hExist = new EventWaitHandle(false, EventResetMode.ManualReset);

        public void Put(WavPack aPack)
        {
            m_Lock.WaitOne();

            Enqueue(new WavPack(aPack));

            if (Count == 1) m_hExist.Set();
            m_Lock.Set();
        }
        public void Read(out WavPack aPack)
        {
            m_hExist.WaitOne();
            m_Lock.WaitOne();

            aPack = Dequeue();


            if(Count == 0) m_hExist.Reset();
            m_Lock.Set();
        }
    }
}
